﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Dim query As String = "select distinct shipcountry from orders"
            Dim dt As DataTable = GetData(query)
            ddlCountries.DataSource = dt
            ddlCountries.DataTextField = "shipcountry"
            ddlCountries.DataValueField = "shipcountry"
            ddlCountries.DataBind()
            ddlCountries.Items.Insert(0, New ListItem("Select", ""))
        End If
    End Sub
    Protected Sub ddlCountries_SelectedIndexChanged(sender As Object, e As EventArgs)
        Dim query As String = String.Format("select ShipCity, count(orderid) TotalOrders from orders where shipcountry = '{0}' group by shipcity", ddlCountries.SelectedItem.Value)
        Dim dt As DataTable = GetData(query)

        'Loop and add each datatable row to the Pie Chart Values
        For Each row As DataRow In dt.Rows
            PieChart1.PieChartValues.Add(New AjaxControlToolkit.PieChartValue() With { _
             .Category = row("ShipCity").ToString(), _
             .Data = Convert.ToDecimal(row("TotalOrders")) _
            })
        Next
        PieChart1.Visible = ddlCountries.SelectedItem.Value <> ""
    End Sub


    Private Shared Function GetData(query As String) As DataTable
        Dim dt As New DataTable()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    sda.Fill(dt)
                End Using
            End Using
            Return dt
        End Using
    End Function
End Class
